.left margin
.ifnot hlp
.hl 1 DEFINE / RESET
.X Define / Reset
.endif hlp
.lm +5
.if hlp.i-6;2 ESCAPE__SEQUENCES
.i-6;3 DEFINE
.endif hlp
.s.tp5.I -5; .DEFINE ESCAPE "escape label" [,modifiers] definition
.ifnot hlp
.index DEFINE ESCAPE
.S
defines non printing escape sequences for control of a variety of printers.
Each escape sequence is indicated in the text by either _\ or _^  or a symbol of your choice followed by
another symbol.  For example _^* can enable bolding by issuing a sequence
to turn on bolding and _\* may disable bolding by issuing a turn off
sequence.  The escape sequence is entered as follows.  First you select
which 2 character label. The first character
must be either _^,_\, or your flag character,
while the second one may be any other character.
They are entered as a literal.  For example the label _^_* may be entered as
"_^_*" or '_^_*' or "_^","_*".
.bb
Your flag character is defined by the .FLAGS ESCAPE command.
.p
Next the modifiers are entered.  These define how the escape sequence is
handled.  The modifiers are:
.endif hlp
.if hlp
.c; Modifiers
.endif hlp
.lm+10
.i-5; LCK - escape sequence is a lock/unlock pair.
.ifnot hlp
For example if _^_* and _\_* are defined as a lock/unlock pair, then the
first appearance of _^_* will "lock" this feature on and a subsequent
appearance of _^_* will be ignored if _\_* is not used in between them.
Effectively the lock is _^_* and unlock is _\_*.
In addition this allows RNO to control these sequences to prevent them from
acting on the headers.  They will only change the text, much in the same way
the underline flag works.
If a line contains only the "lock" sequence then the unlock sequence will
be automatically output at the end off the line.  The next line will then
automatically be preceeded by the lock sequence.
This continues till the input text contains the "unlock" sequence flag.
.endif hlp
.i-5; VSP,spacing - escape sequence changes vertical position by spacing.
.ifnot hlp
This allows you to define a sequence which changes the vertical position.
The spacing parameter is specified in half lines with 1 being
1/2 line advance, -1 1/2 line backwards.
.endif hlp
.i-5; HSP,spacing - sequence modifies the horizontal position by spacing.
.ifnot hlp
You may define a sequence which modifies the horizontal position.
.endif hlp
.i-5; PSP - The horizontal spacing specified by HSP is applied to all
.ifnot hlp
printable characters following the escape sequence.
This attribute modifies the HSP attribute.  You can define a sequence
which changes the character width, and let RNO know what the new width is.
The width may only be 0,1,2,... or multiples of the normal width.
If the HSP is specified as a number other than 1, certains aspects of fill
are disabled.  Spaces will not be expanded if necessary to justify.  Only
"normal" spaces with HSP=1 are expanded.  This allows imbedding extra wide
text inside normal text, or centering extra wide text.  A whole line of extra
wide text can not be justified, but a mixed line of normal and wide can
be justified.
This restriction may be removed in future releases of RNO.
.endif hlp
.i-5; CHR - The lock/unlock pair is used to change only 1 printable character.
.ifnot hlp
This attribute is used only if the lock/unlock pair is designed to function
similarly to the underline flag.  You must also declare the escape character
in a .FLAGS SPECIAL command.
.endif hlp
.lm-10
.ifnot hlp
.p
Then following this the escape sequence is entered.  Printable characters
may be entered as literals ('This is a literl'), while non printable
must be entered as a decimal value.  The following example shows
the definition of an escape sequence to turn on bolding, and turn off bolding
for a FLORIDA DATA printer.
.s.tp5.i5; .DEFINE ESCAPE '_^*',ES.CHR,ES.LCK,33,'W'
.I +5; .DEFINE ESCAPE '_\*',ES.CHR,ES.LCK,33,'_&'
.i5; .FLAGS SPECIAL *
.p
The net effect of these definitions is to have _^_* turn on bolding,
_\_* turn off bolding and _* will bold a single character following it.
Bolding will never occurr for titles, page numbers and subtitles.
.eb
.s
The literals may be enclosed in either single (') or double (") quotes.
If a literal is started by a single quote it must be terminated by a single
quote, but it may contain a double quote.  Similarly a literal enclosed
in double quotes may contain a single quote.
The numbers and literals may be separated by blanks,tabs, and or commas.
Two commas in a row constitute a null and are illegal.
If you define an escape sequence twice in your text only the first
definition will be obeyed unless you reset escape before the second one.
.bb
The second definition will cause an error message.
.p
If you use a large number of different escape sequences frequently,
you should define the most commonly used ones first.  This will
increase the speed with which RUNOFF can find them.
.eb
.note
Escape sequences are output without any interpretation.  If the
sequence leaves the carriage of your printer on a different column than before,
and you have not defined the HSP attribute,
the output line will not fill or justify properly.  Similarly any net vertical
movement while not as serious, is not accounted for if VSP is not defined.
.bb
If an escape sequence is defined which conflicts with a flag, the flag
will be obeyed and the escape sequence ignored if the flag recognition is
enabled by a .FLAGS command.
.eb
.end note
.endif hlp
.if hlp;.i-6;3 RESET
.s.tp5.I -5; .RESET ESCAPE
.s.INDEX RESET ESCAPE
resets all escape sequences.  This clears the table of escape sequences so you
may enter a new one by using .DEFINE ESCAPE.
After giving this command all escape sequences are no longer defined.
.if hlp.i-6;2 SUBSTITUTION
.i-6;3 RESET
.endif hlp
.S.TP 5.I-5; .RESET SUBSTITUTE
.S.INDEX RESET SUBSTITUTE
resets the table of substitutions so that all the previous ones are no longer
defined.
The permanently defined substitutions ($$DATE...) are also no longer defined.
.if hlp.i-6;3 DEFINE
.endif hlp
.s.tp 15.i-5; .DEFINE SUBSTITUTE /label/ text
.INDEX DEFINE SUBSTITUTE
.s
defines a substitution to be made in the text.
The label is preceeded and followed by a delimiter of your choice.  The label
must be no more than 10 characters long and may not contain spaces or tabs.
The command and the first delimiter must be separated by one or more
spaces or tabs,  but no spaces are necessary after the second delimiter unless
you wish to include them in the text.
When the substitute flag is encountered in your text
followed by a defined label, the specified text will be substituted
for the flag+label.  The text may contain another substitution.
Up to 3 levels of substitution may be nested.
The rules for multiple definitions of escape sequences also apply to
substitutions.
.if hlp.i-6;4 EXAMPLE
.endif hlp
.s; EXAMPLE:
You wish to abbreviate the phrase:
.i 5; The party of the first part
.s;So you define and enable substitution:
.i5; .DEFINE SUBSTITUTE /P1$/The party of the first part
.i5; .FLAGS SUBSTITUTE
.s;Then every time you type into the text $P1$ you get instead
the substitute phrase:
.i5;The party of the first part
.if hlp.i-6;4 DELIMITERS
.endif hlp
.br;The example of define substitute could have used different delimiters
if you needed to used the delimiters in the text. For example it could
be done as follows:
.i5; .DEFINE SUBSTITUTE :P1$:The party of the first part
.I15; ... or
.i5; .DEFINE SUBSTITUTE "P1$"The party of the first part
.p
.bb
.if hlp.i-6;4 LABELS
.br
.endif hlp
The substitution label or name may consist of any printable character.
Upper case or lowercase letters may be used, however the case of the
letter will be ignored except for the first character.  In other words
the following commands are equivalent.
.i5; .DEFINE SUBSTITUTE /ABC/
.i5; .DEFINE SUBSTITUTE /Abc/
.i5; .DEFINE SUBSTITUTE /AbC/
.br;But the following are not equivalent.
.i5; .DEFINE SUBSTITUTE /aBC/
.i5; .DEFINE SUBSTITUTE /ABC/
.if hlp.i-6;4 DSR__CONVENTIONS
.endif hlp
.p
A special convention is used to define DSR compatible substitutions.
If the first character of the substitution name is a dollar sign,
the dollar sign stands for
the substitute flag.  If the substitute flag is changed to a character other
than the dollar sign then the defined substitution is considered to begin with
the new substitute flag.  When the substitution is searched for,
the case of the input characters is ignored.
An example of such a substitution is the $$DATE permanently
defined substitution.
.s.lm+10.no fill.i-5; For example the following input:
 .FLAGS SUBSTITUTE @
 .DEFINE SUBSTITUTE /$TEST/This is a test
@@test !!
.i-5; Will produce the following line:
 This is a test !!
.lm-10.fill
.eb
.ifnot hlp
.p
The substitution is a really invaluable aid for defining
complicated mathematical symbols.  All you need to enter in the text
is the simple abbreviation and the complicated symbol will be
substituted.  The substitution may contain all kinds of escape sequences
overstrike symbols and so on to construct the special symbol needed.
.lm
.hl 1 MISC COMMANDS
.lm +5
.endif hlp
.if hlp;.i-6;2 REQUIRE__COMMAND
.endif hlp
.s.tp5.I -5; .REQUIRE 'filename'
.i -5; .REQ 'filename'
.INDEX REQUIRE
.S
takes the input text from the specified file.  The .REQUIRE command may be
imbedded in files which have been required.  The required files may be nested
until 5 input files are open at once. An attempt to require a sixth level of input will cause an error.
The default filetype is .RNO.
The filename may be enclosed in either single (') or double (") quotes.
If any commands follow this command on the same line, they will be
ignored.
.if hlp.i-6;3 EXAMPLE1
.endif hlp
.s
This command makes it easy for you to break up your text into reasonable
chunks.  For example you may wish to put each section in a separate file
and then have a master file which requires each section in order.  If
you need to rearrange the order of the sections you only need to change
the .REQUIRE statements in the master file.  You also should put the
overall formatting commands such as .PAGE SIZE, .DISPLAY, .HEADER ...
into a separate file which may be required at the beginning of each section.
.p
You may also wish to build up files of commonly used substitutions
and escape sequences.  These can then be easily required at the beginning
of any file that needs them.
.if hlp.i-6;3 EXAMPLE2
.endif hlp
.p
Another example is generation of a series of letters with the same
body but different inside addresses and salutations.  You would
make a master file containing the inside addresses and salutations.
After each salutation you might put:
.i5; .REQUIRE "LETTER"
.br; You would then create a file LETTER.RNO with the actual text of the letter.
By running the master file through RNO you would get a string of personalized
letters.  Later on you may change the contents of LETTER.RNO to get another
set of personalized letters for mass mailings.
.if hlp.i-6;2 COMMENTS
.endif hlp
.s.tp6.i-5;  .COMMENT text 
.i-5; #text 
.s.index COMMENT 
causes the line to be ignored. The text is not printed in the output .
Comments may contain useful information which you need when re-editing
the file.  For example you may wish to add comments to a string
of .DEFINE ESCAPE and .DEFINE SUBSTITUTE to remind you what each
escape sequence and substitution does.
